#ifndef _MINE_H
#define _MINE_H

/*
 * another bug in the actual gcc -- it doesn't save %a4, as it isn't
 * supposed to be destroyed; SysTraps() however do this casually;
 * place these macros in EventHandler routines and callback functions.
 */
register void *reg_a4 asm("%a4");
#define CALLBACK_PROLOGUE \
    void *save_a4 = reg_a4; asm("move.l %%a5,%%a4; sub.l #edata,%%a4" : :);
#define CALLBACK_EPILOGUE reg_a4 = save_a4;

#define WIDTH           16
#define HEIGHT          14
#define NAMLEN          11

typedef int (*func) (SWord, SWord);

typedef struct {
  int  version;
  Byte showAll;
  Byte level;
  Byte minefield[WIDTH][HEIGHT];
  Byte done;
  Byte seconds;
  struct {
    char name[NAMLEN];
    int score;
    ULong date;
  } hscore[4][5];
} Game;

extern int score;
extern Game game;

#ifdef DEBUG
void StartDebug();
#endif

#endif
